;Uses extra bits = YES
;See readme for details 




RAM_WARPSTARFLAG = $7EC20D	; free ram
RAM_TIMER = $7EC20E		;




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; INIT and MAIN JSL targets
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
                    LDA #$01		     ;\ Initial Facing (right)
                    STA $157C,x		     ;/
		    LDA #$00		     ;\ Initial X speed (type 1 only)
		    STA $B6,x		     ;/ 
		    LDA #$00		     ;\ Initial Y speed (type 1 only)
		    STA $C2,x		     ;/ C2 is where y velocity is stored outside of AA
		    LDA #$00		     ;\ "mario is on warpstar" flag
		    STA RAM_WARPSTARFLAG     ;/
		    LDA #$00		     ;\ timer
		    STA RAM_TIMER	     ;/ 
		    LDA #$FF		     ;\ set a misc sprite table (for showing mario on warpstar later)
		    STA $1528,x 	     ;/ 
                    RTL		

	                dcb "MAIN"			
                    PHB
                    PHK				
                    PLB				
                    JSR SPRITE_ROUTINE	
                    PLB
                    RTL     


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SPRITE_ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;forwarding
TYPE02
	JMP TYPE2
CheckTouch_0
	JMP CheckTouch

SPEED_TABLE     	dcb $F0,$F0			    ; speeds (right, left)

SPRITE_ROUTINE	  	
	JSR SUB_GFX
        LDA $14C8,x		; return if sprite status != 8
        CMP #$08            	 
        BNE RETURN           
        LDA $9D		    	; return if sprites locked
        BNE RETURN    
        JSR SUB_OFF_SCREEN_X0   ; only process sprite while on screen             

	LDA $7FAB10,x           ;\extra bits check
	AND #$04		; | Head to type 2 code if extra bit set
	BNE TYPE02		;/
	LDA RAM_WARPSTARFLAG    ;\
	CMP #$01		; | if mario hasn't hopped on yet, 
	BNE DONT_MOVE_Y         ;/ don't shoot mario into the sky
	LDA $C2,x		;\
	STA $AA,x 		; | upward speed increases every frame
	DEC $C2,x		;/
	BRA STATE2
	DONT_MOVE_Y
	STZ $AA,x		;y movement failsafe 
        LDA $C2,x               ;\ y movement
	BEQ NOSHIFT_Y	    	; | If an initial x or y velocity is set, this will decrease it by 1 each frame
	STA $AA,x 		; | Useful if you want it to pop out of something
	DEC $C2,x		; |
	NOSHIFT_Y		;/ 
        LDA $B6,x               ;\ X movement
	BEQ NOSHIFT_X	    	; | NOTE: Y velocity is assumed positive, and x velocity negative. If you have a negative y, or positive x,
	INC $B6,x 		; | you must change these accordingly or it'll speed up instead of slow down
	NOSHIFT_X		;/

        JSL $01802A             ; update position based on speed values
        BRA CheckTouch_0        ; check for mario/sprite contact       
        RETURN
        RTS

STATE2  STZ $B6,x		;\ Set x speed to 0
	JSL $01802A		;/ Update pos based on speed values
	JSR MARIO_ON_WARPSTAR	; Draws mario on the warpstar	
	LDA RAM_TIMER		;\
	CLC			; | Timer for teleport on warpstar
	ADC #$01		; |
	STA RAM_TIMER		; | 
	CMP #$38		; | #$38 = default. lower = faster
	BCC RETURN_00		;/ Returns if timer still counting up
	LDA $1528,x		;\
	CMP #$FF		; |
	BEQ NOMARIOREDRAW_00	; |
	LDA $1528,x		; | Restores mario's powerup if it was changed for the warpstar
	STA $19			; |
	LDA #$FF		; |
	STA $1528,x		; |
	NOMARIOREDRAW_00	;/
	JMP TELE		; Teleport

RETURN_00
	RTS


CheckTouch:
	JSL $01A7DC      	; Check for mario/sprite contact (carry set = contact)
        BCC RETURN_00           ; return if no contact
        LDA #$00              	;\
	STA $148F             	;/ Prevents mario from carrying things through the level change
	LDA #$FF		;\ Stops sprite from "touching" mario further
	STA $154C,x		;/
	JSR MARIO_ON_WARPSTAR	; Draws mario on the warpstar	
	LDA #$01		;\ "mario is on warpstar" flag
	STA RAM_WARPSTARFLAG	;/ 
	STZ $B6,x		; Sets X speed to 0 (to not interfere with initial velocities)
	STZ $AA,x		; Sets y speed to 0
	RTS	

MARIO_ON_WARPSTAR		;Routine to draw mario on the warpstar
	LDA $19			;\
	BEQ DRAW_SMALL		;/ Do alternate drawing for small mario
	LDA #$40		;\
	STA $0D91		; | hide mario's feet
	LDA #$55		; |
	STA $0D92		;/
	LDA #$40		;\
	STA $0D87		; | hide mario's lower torso
	LDA #$55		; |
	STA $0D88		;/
	LDA #$3C		;\
	STA $0D86		; | show mario's upper face
	LDA #$00		; |
	STA $0D85		;/
	LDA #$00		;\
	STA $0D8F		; | show mario's lower face
	LDA #$3E		; |
	STA $0D90		;/
	LDA $14E0,x		;\ Place mario on warpstar
	STA $95			; | High X byte
	LDA $14D4,x		; | High Y byte
	STA $97			; |
	LDA $E4,x 		; | Low X byte  
	CLC			; |
	SBC #$05		; |
	STA $94			; |
	BCS CARRYOVER	        ; | \
	DEC $95                 ; |  | Fixes a bug if warpstar goes through screen border
	CARRYOVER	        ; | /
	LDA $D8,x 		; | Low Y byte
	CLC			; |
	SBC #$07		; |
	STA $96			; |
	BCS CARRYOVER_Y		; | \
	DEC $97                 ; |  | Fixes a bug if warpstar goes through screen border
	CARRYOVER_Y		;/  /
	RTS

DRAW_SMALL
	LDA #$40		;\
	STA $0D91		; | hide mario's feet
	LDA #$55		; |
	STA $0D92		;/
	LDA #$40		;\
	STA $0D87		; | show mario's face
	LDA #$3C		; |
	STA $0D88		;/
	LDA #$00		;\
	STA $0D8F		; | show top of mario's hat
	LDA #$36		; |
	STA $0D90		;/
	LDA $14E0,x		;\ Place mario on warpstar
	STA $95			; | High X byte
	LDA $14D4,x		; | High Y byte
	STA $97			; |
	LDA $E4,x 		; | Low X byte  
	CLC			; |
	SBC #$05		; |
	STA $94			; |
	BCS CARRYOVER_S		; | \
	DEC $95                 ; |  | Fixes a bug if warpstar goes through screen border
	CARRYOVER_S		; | /
	LDA $D8,x 		; | Low Y byte
	CLC			; |
	SBC #$0C		; |
	STA $96			; |
	BCS CARRYOVER_Y_S	; | \
	DEC $97                 ; |  | Fixes a bug if warpstar goes through screen border
	CARRYOVER_Y_S		;/  /
	RTS	


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;TELEPORTING STUFF HERE
;
;You can set what level you want to go to based on what level you're on
;See below
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TELE			
	LDA $5B		 
	BEQ Horz	 

	LDX $97
	BRA Setup
Horz
	LDX $95		;mario X pos high

Setup	LDA $13BF	; Loads Level number (if >24, add DC)
	CMP #$29	; Level 105
	BEQ TELEPORT_00 ; Branches to TELEPORT_00 if it's level 105.
	LDA $13BF	; Loads Level number (if >24, add DC)
	CMP #$0A	; Level 10
	BEQ TELEPORT_01 ; Add more of these if you wish
	BRA DEFAULT_TELE

TELEPORT_00
	PEA TELEPORT_DEST_00
	PLA		;low byte
	STA $19B8,x	;write exit table
	PLA		;high byte
	ORA #$04	;exit present
	ORA #PROPERTIES_00	
	STA $19D8,x	;write high bit and properties
	LDA #$06	;teleport
	STA $71
	STZ $89
	STZ $88
	RTS		;return


TELEPORT_01
	PEA TELEPORT_DEST_01
	PLA		;low byte
	STA $19B8,x	;write exit table
	PLA		;high byte
	ORA #$04	;exit present
	ORA #PROPERTIES_01	
	STA $19D8,x	;write high bit and properties
	LDA #$06	;teleport
	STA $71
	STZ $89
	STZ $88
	RTS		;return

DEFAULT_TELE
	PEA TELEPORT_DEST_DEFAULT
	PLA		;low byte
	STA $19B8,x	;write exit table
	PLA		;high byte
	ORA #$04	;exit present
	ORA #PROPERTIES_DEFAULT	
	STA $19D8,x	;write high bit and properties
	LDA #$06	;teleport
	STA $71
	STZ $89
	STZ $88
	RTS		;return

TELEPORT_DEST_00 = $0001	;set this to where you want to head when you teleport
PROPERTIES_00 = $00		;
TELEPORT_DEST_01 = $0109	;These levels are numbered as you see them in Lunar Magic
PROPERTIES_01 = $0A		;used as secondary exit and water flag on (see properties comments below)
TELEPORT_DEST_DEFAULT = $0033	
PROPERTIES_DEFAULT = $00		


;properties byte: 0000w0s0
;w = destination water
;s = secondary exit flag	
	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;End of teleport specific code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;Type 2 specific code

ON_GND_1
	JMP ON_GND		;forwarding

TYPE2
	LDA $19                 ;\ checks to see if mario has cape 
	CMP #$10		;/
	BNE DONT_REDRAW_MARIO	; All this is to prevent the cape from being drawn and looking silly
	LDA $19                 ;\ stores mario's powerup
	STA $1528,x		;/
	LDA #$01		;\ sets mario to big
	STA $19			;/
	DONT_REDRAW_MARIO
        LDA $1588,x             ; set speeds if not on the ground
        AND #$04                ;
        BNE ON_GND_1        	; branches if it is
	LDA #$2F		;\ sets death timer. Set every frame in the air, so doesn't start 
	STA $1540,x		;/ counting down until it hits the ground
	LDA #$15		;\
	STA $AA,x		; | falling speeds
	LDA #$15		; |
	STA $B6,x		;/
        JSL $01802A             ; update position based on speed values
	JSR MARIO_ON_WARPSTAR	; Draws mario on the warpstar	
	RTS
	



ON_GND 
	LDA $1540,x		;\
	CMP #$2D		; | plays a sound effect before dying
	BNE NOSOUNDEFFECT	;/ also prevents mario from dying in the ground
	LDA #$09                ; \ play sound effect
        STA $1DFC               ; /
	LDA $96			;\
	CLC			; | Move mario up so he doesn't die
	SBC #$07		; |
	STA $96			;/
	LDA $19			;\
	BNE NOSOUNDEFFECT	; | If small mario, move back down a bit so it looks better
	LDA $96			; |
	CLC			; |
	ADC #$08		; |
	STA $96			;/
	NOSOUNDEFFECT		;
	LDA $1528,x		;\
	CMP #$FF		; |
	BEQ NOMARIOREDRAW	; |
	LDA $1528,x		; | Restores mario's powerup if it was changed for the warpstar
	STA $19			; |
	LDA #$FF		; |
	STA $1528,x		; |
	NOMARIOREDRAW		;/
	LDA #$FF		;\ Disable any contact with mario
	STA $154C,x		;/
	LDA $1540,x
	CMP #$02
	BNE XPLODE
	STZ $1540,x
	STZ $14c8,x
	RTS
	XPLODE
	PHB
        LDA #$02
        PHA
       	PLB
       	JSL $028086
        PLB
	RTS


STAR_SOUNDS         dcb $00,$13,$14,$15,$16,$17,$18,$19

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GRAPHICS ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GFX             



		    JSR GET_DRAW_INFO       ; after: Y = index to sprite OAM ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
                    
                    LDA $157C,x             ; $02 = sprite direction
                    STA $02


		    LDA RAM_WARPSTARFLAG
	            CMP #$01
	            BEQ PART2B
		    LDA $7FAB10,x           ;extra bits check
		    AND #$04
		    CMP #$04
		    BEQ PART2A

                    LDA $00                 ; set x position of the tile
                    STA $0300,y

                    LDA $01                 ; set y position of the tile
                    STA $0301,y

		    PHX                     ; set tile number
                    LDA $13 		    ; $13 is the animation frame number
		    AND #$1F          	    ; 0 if animation frame number is > 4, 1 if <= 4
		    TAX 		    
		    LDA #$2C                ; tile 80 will be used if it's in animation frame 1-4
		    CPX #$08
		    BCC ANIEND 		
		    LDA $13
		    AND #$1F          	    ; 0 if animation frame number is > 8, 1 if <= 8
		    TAX 		    
		    LDA #$2E                ; tile 82 will be used if it's in animation frame 5-8
		    CPX #$10
		    BCC ANIEND
		    LDA $13
		    AND #$1F          	    ; 0 if animation frame number is > b, 1 if <= b
		    TAX 		    
		    LDA #$40                ; tile 84 will be used if it's in animation frame 9-b
		    CPX #$18
		    BCC ANIEND
		    LDA #$42                ; TILE 86 will be used otherwise
		    ANIEND
	            PLX
                    STA $0302,y

                    LDA $15F6,x             ; get sprite palette info
                    PHX
                    LDX $02                 ; flip the tile if the sprite direction is 0
                    BNE NO_FLIP_1
                    ORA #$40
NO_FLIP_1           PLX
                    ORA $64                 ; add in the priority bits from the level settings
                    STA $0303,y             ; set properties
		    

                    INY                     ; get the index to the next slot of the OAM
                    INY                     ; (this is needed if you wish to draw another tile)
                    INY
                    INY
                    
                    LDY #$02                ; #$02 means the tiles are 16x16
                    LDA #$00                ; This means we drew one tile
                    JSL $01B7B3
                    RTS

PART2A              LDA $1540,x
	            CMP #$2E
		    BEQ PART2B
		    RTS


PART2B   	    

                    LDA $00                 ; set x position of the tile
		    CLC
		    SBC #$04
                    STA $0300,y

                    LDA $01                 ; set y position of the tile
		    CLC
		    SBC #$04
                    STA $0301,y

		    LDA #$4A                ;set tile number
                    STA $0302,y

                    LDA $15F6,x             ; get sprite palette info
                    PHX
                    LDX $02                 ; flip the tile if the sprite direction is 0
                    BNE NO_FLIP_A
                    ORA #$40
NO_FLIP_A           PLX
                    ORA $64                 ; add in the priority bits from the level settings
                    STA $0303,y             ; set properties

                    INY                     ; get the index to the next slot of the OAM
                    INY                     ; (this is needed if you wish to draw another tile)
                    INY
                    INY

                    LDA $00                 ; set x position of the tile
		    CLC
		    ADC #$0F
		    SBC #$04
                    STA $0300,y

                    LDA $01                 ; set y position of the tile
		    CLC
		    SBC #$04
                    STA $0301,y

		    LDA #$4C                ;set tile number
                    STA $0302,y

                    LDA $15F6,x             ; get sprite palette info
                    PHX
                    LDX $02                 ; flip the tile if the sprite direction is 0
                    BNE NO_FLIP_B
                    ORA #$40
NO_FLIP_B           PLX
                    ORA $64                 ; add in the priority bits from the level settings
                    STA $0303,y             ; set properties

                    INY                     ; get the index to the next slot of the OAM
                    INY                     ; (this is needed if you wish to draw another tile)
                    INY
                    INY
                    LDA $00                 ; set x position of the tile
		    CLC
		    SBC #$04
                    STA $0300,y

                    LDA $01                 ; set y position of the tile
		    CLC
		    SBC #$F0
		    SBC #$04
                    STA $0301,y

		    LDA #$4E                ;set tile number
                    STA $0302,y

                    LDA $15F6,x             ; get sprite palette info
                    PHX
                    LDX $02                 ; flip the tile if the sprite direction is 0
                    BNE NO_FLIP_C
                    ORA #$40
NO_FLIP_C           PLX
                    ORA $64                 ; add in the priority bits from the level settings
                    STA $0303,y             ; set properties

                    INY                     ; get the index to the next slot of the OAM
                    INY                     ; (this is needed if you wish to draw another tile)
                    INY
                    INY

                    LDA $00                 ; set x position of the tile
		    CLC 
	  	    ADC #$0F
		    SBC #$04
                    STA $0300,y

                    LDA $01                 ; set y position of the tile
		    CLC
		    SBC #$F0
		    SBC #$04
                    STA $0301,y

		    LDA #$60                ;set tile number
                    STA $0302,y

                    LDA $15F6,x             ; get sprite palette info
                    PHX
                    LDX $02                 ; flip the tile if the sprite direction is 0
                    BNE NO_FLIP_D
                    ORA #$40
NO_FLIP_D           PLX
                    ORA $64                 ; add in the priority bits from the level settings
                    STA $0303,y             ; set properties

                    INY                     ; get the index to the next slot of the OAM
                    INY                     ; (this is needed if you wish to draw another tile)
                    INY
                    INY
                    
                    LDY #$02                ; #$02 means the tiles are 16x16
                    LDA #$03                ; This means we drew one tile
                    JSL $01B7B3
                    RTS






;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ROUTINES FROM THE LIBRARY ARE PASTED BELOW
; You should never have to modify this code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GET_DRAW_INFO
; This is a helper for the graphics routine.  It sets off screen flags, and sets up
; variables.  It will return with the following:
;
;       Y = index to sprite OAM ($300)
;       $00 = sprite x position relative to screen boarder
;       $01 = sprite y position relative to screen boarder  
;
; It is adapted from the subroutine at $03B760
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1              dcb $0C,$1C
SPR_T2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC SPR_T1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA SPR_T2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_OFF_SCREEN
; This subroutine deals with sprites that have moved off screen
; It is adapted from the subroutine at $01AC0D
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
SPR_T12             dcb $40,$B0
SPR_T13             dcb $01,$FF
SPR_T14             dcb $30,$C0,$A0,$C0,$A0,$F0,$60,$90		;bank 1 sizes
		            dcb $30,$C0,$A0,$80,$A0,$40,$60,$B0		;bank 3 sizes
SPR_T15             dcb $01,$FF,$01,$FF,$01,$FF,$01,$FF		;bank 1 sizes
					dcb $01,$FF,$01,$FF,$01,$00,$01,$FF		;bank 3 sizes

SUB_OFF_SCREEN_X1   LDA #$02                ; \ entry point of routine determines value of $03
                    BRA STORE_03            ;  | (table entry to use on horizontal levels)
SUB_OFF_SCREEN_X2   LDA #$04                ;  | 
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X3   LDA #$06                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X4   LDA #$08                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X5   LDA #$0A                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X6   LDA #$0C                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X7   LDA #$0E                ;  |
STORE_03			STA $03					;  |            
					BRA START_SUB			;  |
SUB_OFF_SCREEN_X0   STZ $03					; /

START_SUB           JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
                    BEQ RETURN_35           ; /
                    LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
                    AND #$01                ; |
                    BNE VERTICAL_LEVEL      ; /     
                    LDA $D8,x               ; \
                    CLC                     ; | 
                    ADC #$50                ; | if the sprite has gone off the bottom of the level...
                    LDA $14D4,x             ; | (if adding 0x50 to the sprite y position would make the high byte >= 2)
                    ADC #$00                ; | 
                    CMP #$02                ; | 
                    BPL ERASE_SPRITE        ; /    ...erase the sprite
                    LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0756 VC:176 00 FL:205
                    AND #$01                ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0780 VC:176 00 FL:205
                    ORA $03                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0796 VC:176 00 FL:205
                    STA $01                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0820 VC:176 00 FL:205
                    TAY                     ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0844 VC:176 00 FL:205
                    LDA $1A                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0858 VC:176 00 FL:205
                    CLC                     ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0882 VC:176 00 FL:205
                    ADC SPR_T14,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0896 VC:176 00 FL:205
                    ROL $00                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizcHC:0928 VC:176 00 FL:205
                    CMP $E4,x               ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:0966 VC:176 00 FL:205
                    PHP                     ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:0996 VC:176 00 FL:205
                    LDA $1B                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizCHC:1018 VC:176 00 FL:205
                    LSR $00                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdiZCHC:1042 VC:176 00 FL:205
                    ADC SPR_T15,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizcHC:1080 VC:176 00 FL:205
                    PLP                     ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F0 P:eNvMXdizcHC:1112 VC:176 00 FL:205
                    SBC $14E0,x             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1140 VC:176 00 FL:205
                    STA $00                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1172 VC:176 00 FL:205
                    LSR $01                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1196 VC:176 00 FL:205
                    BCC SPR_L31             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1234 VC:176 00 FL:205
                    EOR #$80                ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1250 VC:176 00 FL:205
                    STA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1266 VC:176 00 FL:205
SPR_L31             LDA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1290 VC:176 00 FL:205
                    BPL RETURN_35           ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1314 VC:176 00 FL:205
ERASE_SPRITE        LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
                    CMP #$08                ; |
                    BCC KILL_SPRITE         ; /    
                    LDY $161A,x             ;A:FF08 X:0007 Y:0001 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1108 VC:059 00 FL:2878
                    CPY #$FF                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1140 VC:059 00 FL:2878
                    BEQ KILL_SPRITE         ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1156 VC:059 00 FL:2878
                    LDA #$00                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1172 VC:059 00 FL:2878
                    STA $1938,y             ;A:FF00 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZcHC:1188 VC:059 00 FL:2878
KILL_SPRITE         STZ $14C8,x             ; erase sprite
RETURN_35           RTS                     ; return

VERTICAL_LEVEL      LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ; \
                    LSR A                   ; | 
                    BCS RETURN_35           ; /
                    LDA $E4,x               ; \ 
                    CMP #$00                ;  | if the sprite has gone off the side of the level...
                    LDA $14E0,x             ;  |
                    SBC #$00                ;  |
                    CMP #$02                ;  |
                    BCS ERASE_SPRITE        ; /  ...erase the sprite
                    LDA $13                 ;A:0000 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:1218 VC:250 00 FL:5379
                    LSR A                   ;A:0016 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1242 VC:250 00 FL:5379
                    AND #$01                ;A:000B X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1256 VC:250 00 FL:5379
                    STA $01                 ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1272 VC:250 00 FL:5379
                    TAY                     ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1296 VC:250 00 FL:5379
                    LDA $1C                 ;A:001A X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0052 VC:251 00 FL:5379
                    CLC                     ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0076 VC:251 00 FL:5379
                    ADC SPR_T12,y           ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0090 VC:251 00 FL:5379
                    ROL $00                 ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:enVMXdizCHC:0122 VC:251 00 FL:5379
                    CMP $D8,x               ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0160 VC:251 00 FL:5379
                    PHP                     ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0190 VC:251 00 FL:5379
                    LDA.W $001D             ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F2 P:eNVMXdizcHC:0212 VC:251 00 FL:5379
                    LSR $00                 ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdiZcHC:0244 VC:251 00 FL:5379
                    ADC SPR_T13,y           ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdizCHC:0282 VC:251 00 FL:5379
                    PLP                     ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:envMXdiZCHC:0314 VC:251 00 FL:5379
                    SBC $14D4,x             ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0342 VC:251 00 FL:5379
                    STA $00                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0374 VC:251 00 FL:5379
                    LDY $01                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0398 VC:251 00 FL:5379
                    BEQ SPR_L38             ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0422 VC:251 00 FL:5379
                    EOR #$80                ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0438 VC:251 00 FL:5379
                    STA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0454 VC:251 00 FL:5379
SPR_L38             LDA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0478 VC:251 00 FL:5379
                    BPL RETURN_35           ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0502 VC:251 00 FL:5379
                    BMI ERASE_SPRITE        ;A:8AFF X:0002 Y:0000 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0704 VC:184 00 FL:5490

SUB_IS_OFF_SCREEN   LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
                    ORA $186C,x             ; |  
                    RTS                     ; / return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_HORZ_POS
; This routine determines which side of the sprite Mario is on.  It sets the Y register
; to the direction such that the sprite would face Mario
; It is ripped from $03B817
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_HORZ_POS		LDY #$00				;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
					LDA $94					;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
					SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
					SBC $E4,x				;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
					STA $0F					;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
					LDA $95					;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
					SBC $14E0,x				;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
					BPL SPR_L16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
					INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
SPR_L16				RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; This routine determines if Mario is above or below the sprite.  It sets the Y register
; to the direction such that the sprite would face Mario
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SubVertPos:
	LDY #$00
        LDA $96
        SEC
        SBC $D8,x
        STA $0F
        LDA $97
        SBC $14D4,x
        BPL VertIncY
        INY
VertIncY:
        RTS   


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; points routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

STAR_SOUNDS
	dcb $00,$13,$14,$15,$16,$17,$18,$19

SUB_STOMP_PTS:
	PHY                      
        LDA $1697               ; \
        CLC                     ;  | 
        ADC $1626,x             ; / some enemies give higher pts/1ups quicker??
        INC $1697               ; increase consecutive enemies stomped
        TAY                     ;
        INY                     ;
        CPY #$08                ; \ if consecutive enemies stomped >= 8 ...
        BCS NO_SOUND            ; /    ... don't play sound 
        LDA STAR_SOUNDS,y       ; \ play sound effect
        STA $1DF9               ; /   
NO_SOUND:
	TYA                     ; \
        CMP #$08                ;  | if consecutive enemies stomped >= 8, reset to 8
        BCC NO_RESET            ;  |
        LDA #$08                ; /
NO_RESET:
	JSL $02ACE5
        PLY                     
        RTS                     ; return